//---------------------------------------------------------------------------
#include <vcl\vcl.h>
#pragma hdrstop

#include "Unit2.h"
#include "Unit1.h"
//---------------------------------------------------------------------------
//   Important: Methods and properties of objects in VCL can only be
//   used in a method called using Synchronize, for example:
//
//      Synchronize(UpdateCaption);
//
//   where UpdateCaption could look like:
//
//      void __fastcall TSearchThread::UpdateCaption()
//      {
//        Form1->Caption = "Updated in a thread";
//      }
//---------------------------------------------------------------------------
__fastcall TSearchThread::TSearchThread(AnsiString strDir, AnsiString strMask, AnsiString strText, bool CreateSuspended)
   : TThread(false)
{
   FstrDirectory = strDir;
   if ( FstrDirectory[FstrDirectory.Length()-1] != '\\' )
      FstrDirectory += '\\';
   FstrFileMask  = strMask;
   FstrSearchText = strText;
   if ( !CreateSuspended )
      Resume();
}
//---------------------------------------------------------------------------
void __fastcall TSearchThread::Execute()
{
	//    ,    
	//     Win32 API

	WIN32_FIND_DATA FindFileData;
	AnsiString strSearchFiles = FstrDirectory + FstrFileMask;
	HANDLE hFirstFileHandle = FindFirstFile(
			strSearchFiles.c_str(), &FindFileData );

	while ( hFirstFileHandle && !Terminated )

	{
		//     
   		FstrCurFileName = FstrDirectory + FindFileData.cFileName;
		FILE *fp = fopen(FstrCurFileName.c_str(), "r" );
		if (fp == NULL)
		{
			if ( FindNextFile( hFirstFileHandle, &FindFileData)	== FALSE )
		      break;
			continue;
		}

		//     
		char szBuffer[ 256 ];

		while ( !feof(fp) )
		{
			if ( fgets(szBuffer, 255, fp) == NULL )
				break;
			AnsiString s = szBuffer;

			if ( DoFind( FstrSearchText, s ) )
			{
				Synchronize(AddToListBox);
				break;
			}
		}

		//        
		fclose(fp);
		if ( FindNextFile( hFirstFileHandle, &FindFileData ) == FALSE )
				break;
	}
	Form1->SearchComplete();
}
//---------------------------------------------------------------------------

void __fastcall TSearchThread::AddToListBox(void)
{
   if ( FstrCurFileName.Length() )
      Form1->ListBox1->Items->Add( FstrCurFileName );
}

//     
//    
int TSearchThread::DoFind( AnsiString strSearchText, AnsiString& text )
{
   int i=0;
   int nCount = 0;

   while ( i < text.Length() )
   {
      if ( !strncmp(text.c_str()+i, strSearchText.c_str(), strSearchText.Length()) )
      {
         i += strSearchText.Length();
         nCount ++;
      }
      else
      {
         i++;
      }
   }
   return nCount;
}
